<i18n>
{
  "fr": {
    "tab-1": "Tableau de synthèse (kg eCO2)",
    "title-1": "Soumission des données",
    "title-2": "Soumission impossible",
    "label-1": "Part de l'empreinte totale",
    "label-2": "Empreinte carbone du laboratoire",
    "label-3": "Empreinte carbone <em>per capita</em>",
    "label-4": "Intensité carbone",
    "label-5": "Soumis",
    "tooltip-1": "Les enseignants-chercheurs ont une quotité d’appartenance au labo de 50% ; cela signifie que les émissions qu’ils /elles génèrent par leurs consommations d’énergie liées au chauffage de leur bureau et à l’électricité ne sont imputées au labo qu’à hauteur de 50%, que ces personnes passent 100% du temps dans leur bureau du labo, ou aient un autre bureau ailleurs). Les autres personnes du labo ont une quotité d’appartenance au labo de 100%.",
    "tooltip-2": "La quotité totale du laboratoire est de",
    "tooltip-3": "personnes",
    "tooltip-4": "L'intensité carbone correspond aux émissions par euro de budget dépensé.",
    "post-1": "Empreinte carbone des bâtiments",
    "post-2": "Empreinte carbone du matériel informatique",
    "post-3": "Empreinte carbone des déplacements",
    "post-4": "Déplacements domicile-travail",
    "post-5": "Déplacements professionnels",
    "post-6": "Les véhicules",
    "post-7": "Les missions",
    "post-8": "Empreinte carbone totale",
    "post-9": "Empreinte carbone des achats",
    "error-1": "<strong>Aucune donnée disponible</strong> pour le <strong>module « Déplacements domicile / travail »</strong>. Celui-ci est <strong>requis</strong> pour la soumission. <br /> Vous pouvez réaliser l'enquête domicile / travail en suivant les instructions dans l'onglet correspondant à ce module.",
    "error-2": "Veuillez désactiver l'enquête domicile / travail de ce BGES avant de le soumettre.",
    "error-3": "<strong>Aucune donnée disponible</strong> pour le <strong>module « Les missions »</strong>. Celui-ci est <strong>requis</strong> pour la soumission. <br /> Veuillez demander à votre gestionnaire un export des missions afin de les importer dans l'outil.",
    "error-4": "Des <strong>données d'éléctricité et/ou de chauffage sont manquantes</strong> pour le <strong>module « Les bâtiments »</strong>. Celles-ci sont <strong>requises</strong> pour la soumission.",
    "error-5": "<strong>Aucune donnée disponible</strong> pour le <strong>module « Achats »</strong>. Celui-ci est <strong>requis</strong> pour la soumission. <br /> Veuillez demander à votre gestionnaire un export des achats afin de les importer dans l'outil."
  },
  "en": {
    "tab-1": "Overview table (kg CO2e)",
    "title-1": "Data submission",
    "title-2": "Data submission not possible",
    "label-1": "Share of the total footprint",
    "label-2": "Carbon footprint of the laboratory",
    "label-3": "Carbon footprint <em>per capita</em>",
    "label-4": "Carbon intensity",
    "label-5": "Submitted",
    "tooltip-1": "The teaching staff (lecturers, professors) have a  membership ratio of 50%; this means that the emissions they generate through their energy consumption related to office heating and electricity are only attributed to the lab at 50%, whether they spend 100% of their time in their lab office or have another office elsewhere. The other people in the lab have a lab share of 100%.",
    "tooltip-2": "The total member-equivalent count of the laboratory is",
    "tooltip-3": "members",
    "tooltip-4": "The carbon intensity is the ratio of emissions generated by one euro of budget expenditures.",
    "post-1": "Carbon footprint of buildings",
    "post-2": "Carbon footprint of digital devices",
    "post-3": "Carbon footprint of travels",
    "post-4": "Commuting",
    "post-5": "Professional travel",
    "post-6": "Vehicles",
    "post-7": "Business travel",
    "post-8": "Total carbon footprint",
    "post-9": "Carbon footprint of purchases",
    "error-1": "<strong>No data available</strong> for the <strong>« Commuting » module</strong>. This module is <strong>required</strong> for data submission. <br /> You can carry out the commuting survey by following the instructions in the tab corresponding to this module.",
    "error-2": "Please deactivate the commuting survey of this GHG inventory before submitting the inventory",
    "error-3": "<strong>No data available</strong> for the <strong>« Travel » module</strong>. This module is <strong>required</strong> for data submission. <br /> Please ask your accounting department for an export of the trips in order to import them into the tool.",
    "error-4": "Some <strong> electricity and/or heating data are missing</strong> for the <strong>« Building » module</strong>. These ones are <strong>required</strong> for data submission.",
    "error-5": "<strong>No data available</strong> for the <strong>« Purchase » module</strong>. This module is <strong>required</strong> for data submission. <br /> Please ask your accounting department for an export of the purchases in order to import them into the tool."
  }
}
</i18n>

<template>
  <div>
    <b-modal
      :can-cancel="['escape', 'x', 'outside']"
      :active.sync="displayModal"
      has-modal-card
    >
      <div class="modal-card">
        <header class="modal-card-head">
          <p class="modal-card-title">
            {{ $t('title-1') }}
          </p>
        </header>
        <section class="modal-card-body">
          <data-submission
            @data-submitted="forceComputeAllModules"
            :module="currentModule"
          />
        </section>
      </div>
    </b-modal>
    <div class="columns">
      <div class="column">
        <b-notification :closable="false">
          <div class="level-item has-text-centered">
            <div>
              <p class="heading has-text-distance">
                {{ $t('label-2') }}
              </p>
              <div class="title is-size-4 has-text-distance">
                <p>
                  {{ syntheseData.total.intensity.intensity | splitNumberTons }} &plusmn; {{ syntheseData.total.intensity.uncertainty | splitNumberTons }}
                  <span class="is-size-6">{{ $t('t.co2e') }}</span>
                </p>
              </div>
            </div>
          </div>
        </b-notification>
      </div>
      <div class="column">
        <b-notification :closable="false">
          <div class="level-item has-text-centered">
            <div>
              <p class="heading has-text-carbone">
                <b-tooltip
                  size="is-large"
                  multilined
                  position="is-top"
                  dashed type="is-info"
                >
                  <span v-html="$t('label-3')" />
                  <template v-slot:content>
                    {{ $t('tooltip-1') }}
                    <br />
                    {{ $t('tooltip-2') }} <strong>{{ totalPerCapita }} {{ $t('tooltip-3') }}</strong>.
                  </template>
                </b-tooltip>
              </p>
              <div class="title is-size-4 has-text-carbone">
                <p>
                  {{ emissionsPerCapita | splitNumber }} &plusmn; {{ emissionsiPerCapita | splitNumber }}
                  <span class="is-size-6">{{ $t('kg.co2e') }}</span>
                </p>
              </div>
            </div>
          </div>
        </b-notification>
      </div>
      <div class="column">
        <b-notification :closable="false">
          <div class="level-item has-text-centered">
            <div>
              <p class="heading has-text-carbone2">
                <b-tooltip
                  size="is-large"
                  multilined
                  position="is-top"
                  dashed type="is-info"
                >
                  {{ $t('label-4') }}
                  <template v-slot:content>
                    {{ $t('tooltip-4') }}
                  </template>
                </b-tooltip>
              </p>
              <div class="title is-size-4 has-text-carbone2">
                <p>
                  {{ (syntheseData.total.intensity.intensity / budget) * 1000 | splitNumber }} &plusmn; {{ (syntheseData.total.intensity.uncertainty / budget) * 1000 | splitNumber }}
                  <span class="is-size-6">{{ $t('g.co2e') }} / €</span>
                </p>
              </div>
            </div>
          </div>
        </b-notification>
      </div>
    </div>
    <contrails-switch
      :withContrails.sync="withContrails"
      @input="computeAllModules"
    />
    <div class="b-table">
      <div class="table-wrapper">
        <table class="table is-striped is-hoverable has-mobile-cards">
          <thead>
            <tr>
              <th v-if="!isPublic && isAuthenticated">
                <div class="th-wrap">
                  {{ $t('label-5') }}
                </div>
              </th>
              <th>
                <div class="th-wrap">
                  {{ $t('carbon.footprint') }}
                </div>
              </th>
              <th>
                <div class="th-wrap is-numeric">
                  {{ $t('emissions.t.co2e') }}
                </div>
              </th>
              <th>
                <div class="th-wrap is-numeric">
                  {{ $t('label-1') }}
                </div>
              </th>
              <th>
                <div class="th-wrap is-centered pl-0 pr-0"></div>
              </th>
              <th v-if="!isPublic && isAuthenticated">
                <div class="th-wrap is-centered pl-0 pr-0"></div>
              </th>
              <th v-if="!isPublic && isAuthenticated">
                <div class="th-wrap is-centered pl-0 pr-0"></div>
              </th>
            </tr>
          </thead>
          <tbody>
            <tr draggable="false" v-for="(module,index) in Object.keys(syntheseData)" :key="index">
              <td v-if="!isPublic && isAuthenticated" class="has-text-centered">
                <b-icon
                  v-if="syntheseData[module].submitted"
                  icon="check"
                  size="is-small"
                  type="is-success"
                />
                <b-icon
                  v-else
                  icon="times"
                  size="is-small"
                  type="is-danger"
                />
              </td>
              <td>
                <strong v-if="syntheseData[module]['_level'] === 1">
                  {{ syntheseData[module]['name'] }}
                  <purchases-warning v-if="module==='purchases'" ref="purchasesWarning" :isTag="true" />
                </strong>
                <span style=" margin-left: 20px;" v-else-if="syntheseData[module]['_level'] === 2">|-- {{ syntheseData[module]['name'] }}</span>
                <span style=" margin-left: 40px;" v-else-if="syntheseData[module]['_level'] === 3">|-- {{ syntheseData[module]['name'] }}</span>
              </td>
              <td class="has-text-right">
                <strong v-if="syntheseData[module]['_level'] === 1">{{ Math.round(syntheseData[module].intensity.intensity) | splitNumberTons }} &plusmn; {{ Math.round(syntheseData[module].intensity.uncertainty) | splitNumberTons }}</strong>
                <span v-else>{{ Math.round(syntheseData[module].intensity.intensity) | splitNumberTons }} &plusmn; {{ Math.round(syntheseData[module].intensity.uncertainty) | splitNumberTons }}</span>
              </td>
              <td class="has-text-right">
                <strong v-if="syntheseData[module]['_level'] === 1">{{ Math.round(syntheseData[module].intensity.intensity / syntheseData.total.intensity.intensity * 10000 / 100) }} %</strong>
                <span v-else>{{ Math.round(syntheseData[module].intensity.intensity / syntheseData.total.intensity.intensity * 10000 / 100) }} %</span>
              </td>
              <td class="has-text-centered pl-0 pr-0" >
                <b-tooltip
                  v-if="syntheseData[module]['_module']"
                  :label="$t('display')"
                  type="is-black"
                >
                  <b-button
                    size="is-small"
                    :disabled="isDisabled(module)"
                    icon-right="bar-chart"
                    @click="plots(syntheseData[module]['_module'])"
                  />
                </b-tooltip>
              </td>
              <td v-if="!isPublic && isAuthenticated" class="has-text-centered pl-0 pr-0">
                <b-tooltip
                  v-if="syntheseData[module]['_export']"
                  :label="$t('download')"
                  type="is-black"
                >
                  <b-button
                    size="is-small"
                    :disabled="isDisabled(module)"
                    icon-right="download"
                    @click="csvExport(module)"
                  />
                </b-tooltip>
              </td>
              <td v-if="!isPublic && isAuthenticated" class="has-text-centered pl-0 pr-0">
                <b-tooltip
                  v-if="syntheseData[module]['_submit']"
                  :label="$t('submit')"
                  type="is-black"
                >
                  <b-button
                    size="is-small"
                    :disabled="syntheseData[module].submitted"
                    icon-left="paper-plane"
                    type="is-primary"
                    @click="submitData(module)"
                  />
                </b-tooltip>
              </td>
            </tr>
          </tbody>
        </table>
      </div>
    </div>
    <b-modal
      :active.sync="plotsVisible"
      has-modal-card
    >
      <div class="modal-card" style="width: 1100px; height: auto">
        <section class="modal-card-body">
          <plots-commutes v-if="activePlots==='plots-commutes'"/>
          <plots-all-travels
            v-if="activePlots==='plots-all-travels'"
            :withContrails="withContrails"
          />
          <plots-vehicles v-if="activePlots==='plots-vehicles'"/>
          <plots-devices v-if="activePlots==='plots-devices'"/>
          <plots-purchases v-if="activePlots==='plots-purchases'"/>
          <plots-travels
            v-if="activePlots==='plots-travels'"
            :withContrails="withContrails"
          />
          <plots-total
            v-if="activePlots==='plots-total'"
            :title="graphicTitle"
            :data="graphicDataTons"
          />
        </section>
      </div>
    </b-modal>
  </div>
</template>

<script>
import {
  HEATING_COLOR,
  ELECTRICITY_COLOR,
  REFRIGERANTS_COLOR,
  VEHICLES_COLOR,
  TRAVELS_COLOR,
  COMMUTES_COLOR,
  COMPUTERDEVICES_COLOR,
  PURCHASES_COLOR
} from '@/models/definitions.js'
import { commute } from '@/mixins/commute'
import { CarbonIntensity, CarbonIntensities } from '@/models/carbon/CarbonIntensity.js'
import '@/plugins/highcharts.js'
import { mapGetters } from 'vuex'

export default {
  name: 'SyntheseEmpreinte',
  mixins: [commute],
  components: {
    'plots-devices': () => import('@/components/carbon/results/PlotsDevices.vue'),
    'plots-vehicles': () => import('@/components/carbon/results/PlotsVehicles.vue'),
    'plots-purchases': () => import('@/components/carbon/results/PlotsPurchases.vue'),
    'plots-commutes': () => import('@/components/carbon/results/PlotsCommutes.vue'),
    'purchases-warning': () => import('@/components/carbon/forms/PurchasesWarning.vue'),
    'plots-all-travels': () => import('@/components/carbon/results/PlotsAllTravels.vue'),
    'plots-travels': () => import('@/components/carbon/results/PlotsTravels.vue'),
    'plots-total': () => import('@/components/carbon/results/PlotsTotal.vue'),
    'data-submission': () => import('@/components/carbon/results/DataSubmission.vue'),
    'contrails-switch': () => import('@/components/carbon/utils/ContrailsSwitch.vue')
  },
  props: {
    isPublic: {
      type: Boolean,
      default: false
    }
  },
  data () {
    return {
      plotsVisible: false,
      activePlots: null,
      displayModal: false,
      currentModule: null,
      emissionsPerCapita: 0,
      emissionsiPerCapita: 0,
      graphicData: [],
      graphicTitle: '',
      withContrails: true
    }
  },
  computed: {
    ...mapGetters('authentication', ['isAuthenticated']),
    budget () {
      return this.$store.getters['ghgi/item']['budget']
    },
    GHGIyear: function () {
      return this.$store.getters['ghgi/item']['year']
    },
    graphicDataTons () {
      let graphicDataTons = []
      for (let source of this.graphicData) {
        graphicDataTons.push({
          name: source.name,
          y: source.y / 1000,
          color: source.color
        })
      }
      return graphicDataTons
    },
    totalPerCapita () {
      return Number(this.$store.getters['ghgi/item']['nResearcher']) +
             Number(this.$store.getters['ghgi/item']['nProfessor']) / 2 +
             Number(this.$store.getters['ghgi/item']['nEngineer']) +
             Number(this.$store.getters['ghgi/item']['nStudent'])
    },
    nMember () {
      return Number(this.$store.getters['ghgi/nMember'])
    },
    syntheseData () {
      return {
        buildings: {
          'name': this.$t('post-1'),
          'submitted': this.$store.getters['ghgi/item']['buildingsSubmitted'],
          'intensity': new CarbonIntensities(),
          '_level': 1,
          '_module': null,
          '_submit': true,
          '_export': true
        },
        heatings: {
          'name': this.$t('heating'),
          'submitted': this.$store.getters['ghgi/item']['buildingsSubmitted'],
          'intensity': new CarbonIntensity(),
          '_level': 2,
          '_module': null,
          '_submit': false,
          '_export': false
        },
        electricity: {
          'name': this.$t('electricity'),
          'submitted': this.$store.getters['ghgi/item']['buildingsSubmitted'],
          'intensity': new CarbonIntensity(),
          '_level': 2,
          '_module': null,
          '_submit': false,
          '_export': false
        },
        cooling: {
          'name': this.$t('refrigerants'),
          'submitted': this.$store.getters['ghgi/item']['buildingsSubmitted'],
          'intensity': new CarbonIntensity(),
          '_level': 2,
          '_module': null,
          '_submit': false,
          '_export': false
        },
        devices: {
          'name': this.$t('post-2'),
          'submitted': this.$store.getters['ghgi/item']['devicesSubmitted'],
          'intensity': new CarbonIntensity(),
          '_level': 1,
          '_module': 'plots-devices',
          '_submit': true,
          '_export': true
        },
        purchases: {
          'name': this.$t('post-9'),
          'submitted': this.$store.getters['ghgi/item']['purchasesSubmitted'],
          'intensity': new CarbonIntensity(),
          '_level': 1,
          '_module': 'plots-purchases',
          '_submit': true,
          '_export': true
        },
        alltravels: {
          'name': this.$t('post-3'),
          'submitted': this.$store.getters['ghgi/item']['travelsSubmitted'] && this.$store.getters['ghgi/item']['vehiclesSubmitted'] && this.$store.getters['ghgi/item']['commutesSubmitted'],
          'intensity': new CarbonIntensities(),
          '_level': 1,
          '_module': null,
          '_submit': false,
          '_export': false
        },
        commutes: {
          'name': this.$t('post-4'),
          'submitted': this.$store.getters['ghgi/item']['commutesSubmitted'],
          'intensity': new CarbonIntensity(),
          '_level': 2,
          '_module': 'plots-commutes',
          '_submit': true,
          '_export': true
        },
        proTravels: {
          'name': this.$t('post-5'),
          'submitted': this.$store.getters['ghgi/item']['travelsSubmitted'] && this.$store.getters['ghgi/item']['vehiclesSubmitted'],
          'intensity': new CarbonIntensities(),
          '_level': 2,
          '_module': 'plots-all-travels',
          '_submit': false,
          '_export': false
        },
        vehicles: {
          'name': this.$t('post-6'),
          'submitted': this.$store.getters['ghgi/item']['vehiclesSubmitted'],
          'intensity': new CarbonIntensity(),
          '_level': 3,
          '_module': 'plots-vehicles',
          '_submit': true,
          '_export': true
        },
        travels: {
          'name': this.$t('post-7'),
          'submitted': this.$store.getters['ghgi/item']['travelsSubmitted'],
          'intensity': new CarbonIntensity(),
          '_level': 3,
          '_module': 'plots-travels',
          '_submit': true,
          '_export': true
        },
        total: {
          'name': this.$t('post-8'),
          'submitted': this.$store.getters['ghgi/item']['travelsSubmitted'] && this.$store.getters['ghgi/item']['vehiclesSubmitted'] && this.$store.getters['ghgi/item']['commutesSubmitted'] && this.$store.getters['ghgi/item']['buildingsSubmitted'] && this.$store.getters['ghgi/item']['devicesSubmitted'] && this.$store.getters['ghgi/item']['purchasesSubmitted'],
          'intensity': new CarbonIntensities(),
          '_level': 1,
          '_module': 'plots-total',
          '_submit': true,
          '_export': true
        }
      }
    },
    hasPurposeOption: function () {
      return this.$store.getters['travels/hasPurposeOption']()
    },
    hasStatusOption: function () {
      return this.$store.getters['travels/hasStatusOption']()
    },
    commutesIsOK: function () {
      return this.$store.getters['commutes/submitOk']
    },
    surveyActive: function () {
      return this.$store.getters['ghgi/item']['surveyActive']
    },
    travelsIsOK: function () {
      return this.$store.getters['travels/submitOk']
    },
    purchasesIsOK: function () {
      return this.$store.getters['purchases/submitOk']
    },
    buildingsIsOK: function () {
      return this.$store.getters['buildings/submitOk']
    }
  },
  methods: {
    forceComputeAllModules: function () {
      this.displayModal = false
      this.$store.dispatch('buildings/forceComputation')
      this.$store.dispatch('vehicles/forceComputation')
      this.$store.dispatch('commutes/forceComputation')
      this.$store.dispatch('travels/forceComputation')
      this.$store.dispatch('computerdevices/forceComputation')
      this.$store.dispatch('purchases/forceComputation')
      this.computeAllModules()
    },
    resetAllModules: function () {
      this.syntheseData.buildings.intensity = new CarbonIntensities()
      this.syntheseData.heatings.intensity = new CarbonIntensity()
      this.syntheseData.electricity.intensity = new CarbonIntensity()
      this.syntheseData.cooling.intensity = new CarbonIntensity()
      this.syntheseData.devices.intensity = new CarbonIntensity()
      this.syntheseData.purchases.intensity = new CarbonIntensity()
      this.syntheseData.alltravels.intensity = new CarbonIntensities()
      this.syntheseData.commutes.intensity = new CarbonIntensity()
      this.syntheseData.proTravels.intensity = new CarbonIntensities()
      this.syntheseData.vehicles.intensity = new CarbonIntensity()
      this.syntheseData.travels.intensity = new CarbonIntensity()
      this.syntheseData.total.intensity = new CarbonIntensities()
    },
    computeAllModules: function () {
      this.graphicData = []
      this.resetAllModules()
      if (!this.$store.getters['buildings/computed']) {
        this.$store.dispatch('buildings/compute')
      }
      if (!this.$store.getters['vehicles/computed']) {
        this.$store.dispatch('vehicles/compute')
      }
      if (!this.$store.getters['commutes/computed']) {
        this.$store.dispatch('commutes/compute')
      }
      if (!this.$store.getters['travels/computed']) {
        this.$store.dispatch('travels/compute')
      }
      if (!this.$store.getters['computerdevices/computed']) {
        this.$store.dispatch('computerdevices/compute')
      }
      if (!this.$store.getters['purchases/computed']) {
        this.$store.dispatch('purchases/compute')
      }
      this.processBuildings()
      this.processVehicles()
      this.processCommutes()
      this.processTravels()
      this.processComputerDevices()
      this.processPurchases()
      this.graphicTitle = '<strong>' + this.$options.filters.splitNumberTons(Math.round(this.syntheseData.total.intensity.intensity)) + ' ' + this.$t('t.co2e') + ' </strong>'
      // update per capita
      this.emissionsPerCapita = this.syntheseData.total.intensity.intensity - this.syntheseData.buildings.intensity.intensity
      this.emissionsPerCapita = this.emissionsPerCapita / this.nMember
      this.emissionsPerCapita += this.syntheseData.buildings.intensity.intensity / this.totalPerCapita
      // update per capita uncertainity
      this.emissionsiPerCapita = this.syntheseData.total.intensity.uncertainty - this.syntheseData.buildings.intensity.uncertainty
      this.emissionsiPerCapita = this.emissionsiPerCapita / this.nMember
      this.emissionsiPerCapita += this.syntheseData.buildings.intensity.uncertainty / this.totalPerCapita
    },
    plots: function (plotsModule) {
      this.plotsVisible = true
      this.activePlots = plotsModule
    },
    exportGlobal () {
      let csvContent = 'data:text/csv;charset=utf-8,'
      let now = new Date()
      let month = now.getMonth() + 1
      let self = this
      csvContent += [
        Object.keys(self.syntheseData.buildings).filter(column => !column.startsWith('_')).join('\t'),
        ...Object.keys(self.syntheseData).map(function (key) {
          let toReturn = ''
          for (let colName of Object.keys(self.syntheseData[key]).filter(column => !column.startsWith('_'))) {
            if (colName === 'intensity') {
              toReturn += Math.round(self.syntheseData[key][colName].intensity) + '\t'
              toReturn += Math.round(self.syntheseData[key][colName].uncertainty) + '\t'
            } else {
              toReturn += self.syntheseData[key][colName] + '\t'
            }
          }
          return (toReturn)
        })
      ]
        .join('\n')
        .replace(/(^\[)|(\]$)/gm, '')
      const data = encodeURI(csvContent)
      const link = document.createElement('a')
      link.setAttribute('href', data)
      link.setAttribute('download', 'GES1point5_ghgi' + this.GHGIyear + '_total_' + now.getFullYear() + '' + month + '' + now.getDate() + '.tsv')
      link.click()
    },
    exportTravels () {
      let emissions = this.$store.getters['travels/results']
      let csvContent = 'data:text/csv;charset=utf-8,'
      let now = new Date()
      let month = now.getMonth() + 1
      csvContent += [
        ['name', 'type', 'mode', 'amount', 'position', 'no.person', 'purpose', 'round.trip',
          'geodesic.distance.km', 'corrected.distance.km', 'distance.km', 'emission.kg.co2e', 'uncertainty.kg.co2e',
          'emission.withcontrails.kg.co2e', 'uncertainty.withcontrails.kg.co2e', 'total.distance.km',
          'total.emission.kg.co2e', 'total.uncertainty.kg.co2e', 'total.emission.withcontrails.kg.co2e',
          'total.uncertainty.withcontrails.kg.co2e'].join('\t'),
        ...emissions.meta.map(function (item) {
          let toReturn = item.names.join(',') + '\t' + item.type + '\t' + item.transportation + '\t'
          toReturn += item.amount + '\t' + item.status + '\t'
          toReturn += item.carpooling + '\t' + item.purpose + '\t'
          toReturn += item.isRoundTrip + '\t' + Math.round(item.geodesicDistance) + '\t'
          toReturn += Math.round(item.correctedDistance) + '\t'
          toReturn += Math.round(item.distance) + '\t' + Math.round(item.travelIntensity.intensity) + '\t'
          toReturn += Math.round(item.travelIntensity.uncertainty) + '\t' + Math.round(item.travelIntensity.intensitywc) + '\t'
          toReturn += Math.round(item.travelIntensity.uncertaintywc) + '\t' + Math.round(item.cumulativeDistance) + '\t'
          toReturn += Math.round(item.intensity.intensity) + '\t' + Math.round(item.intensity.uncertainty) + '\t'
          toReturn += Math.round(item.intensity.intensitywc) + '\t' + Math.round(item.intensity.uncertaintywc)
          return toReturn
        })
      ]
        .join('\n')
        .replace(/(^\[)|(\]$)/gm, '')
      const data = encodeURI(csvContent)
      const link = document.createElement('a')
      link.setAttribute('href', data)
      link.setAttribute('download', 'GES1point5_ghgi' + this.GHGIyear + '_travels_' + now.getFullYear() + '' + month + '' + now.getDate() + '.tsv')
      link.click()
    },
    exportDevices () {
      let emissions = this.$store.getters['computerdevices/results']
      let csvContent = 'data:text/csv;charset=utf-8,'
      let now = new Date()
      let month = now.getMonth() + 1
      csvContent += [
        ['type', 'model', 'amount', 'emission.kg.co2e', 'uncertainty.kg.co2e'].join('\t'),
        ...emissions.meta.map(function (item) {
          let toReturn = item.type + '\t' + item.model + '\t' + item.amount + '\t'
          toReturn += Math.round(item.intensity.intensity) + '\t' + Math.round(item.intensity.uncertainty)
          return toReturn
        })
      ]
        .join('\n')
        .replace(/(^\[)|(\]$)/gm, '')
      const data = encodeURI(csvContent)
      const link = document.createElement('a')
      link.setAttribute('href', data)
      link.setAttribute('download', 'GES1point5_ghgi' + this.GHGIyear + '_devices_' + now.getFullYear() + '' + month + '' + now.getDate() + '.tsv')
      link.click()
    },
    exportVehicles () {
      let emissions = this.$store.getters['vehicles/results']
      let csvContent = 'data:text/csv;charset=utf-8,'
      let now = new Date()
      let month = now.getMonth() + 1
      csvContent += [
        ['name', 'type', 'engine', 'consumption', 'unit', 'emission.kg.co2e', 'uncertainty.kg.co2e'].join('\t'),
        ...emissions.meta.map(function (item) {
          let toReturn = item.name + '\t' + item.type + '\t' + item.engine + '\t'
          toReturn += item.consumption + '\t' + item.unit + '\t'
          toReturn += Math.round(item.intensity.intensity) + '\t' + Math.round(item.intensity.uncertainty)
          return toReturn
        })
      ]
        .join('\n')
        .replace(/(^\[)|(\]$)/gm, '')
      const data = encodeURI(csvContent)
      const link = document.createElement('a')
      link.setAttribute('href', data)
      link.setAttribute('download', 'GES1point5_ghgi' + this.GHGIyear + '_vehicles_' + now.getFullYear() + '' + month + '' + now.getDate() + '.tsv')
      link.click()
    },
    exportPurchases () {
      let emissions = this.$store.getters['purchases/results']
      let csvContent = 'data:text/csv;charset=utf-8,'
      let now = new Date()
      let month = now.getMonth() + 1
      let self = this
      csvContent += [
        ['code', 'module', 'scope.source', 'category', 'description', 'amount.euro',
          'emission.kg.co2e', 'uncertainty.kg.co2e'].join('\t'),
        ...emissions.meta.map(function (item) {
          let toReturn = item.code.toUpperCase() + '\t' + item.module + '\t' + item.scope3 + '\t'
          toReturn += self.$t(item.category) + '\t' + item.description + '\t' + item.amount + '\t'
          toReturn += Math.round(item.intensity.intensity) + '\t' + Math.round(item.intensity.uncertainty)
          return toReturn
        })
      ]
        .join('\n')
        .replace(/(^\[)|(\]$)/gm, '')
      const data = encodeURI(csvContent)
      const link = document.createElement('a')
      link.setAttribute('href', data)
      link.setAttribute('download', 'GES1point5_ghgi' + this.GHGIyear + '_purchases_' + now.getFullYear() + '' + month + '' + now.getDate() + '.tsv')
      link.click()
    },
    exportBuildings () {
      let emissions = this.$store.getters['buildings/results']
      let csvContent = 'data:text/csv;charset=utf-8,'
      let now = new Date()
      let month = now.getMonth() + 1
      csvContent += ['name', 'site', 'floor.area', 'share',
        'self.production', 'self.consumption',
        'heating.emission.kg.co2e', 'heating.uncertainty.kg.co2e',
        'electricity.emission.kg.co2e', 'electricity.uncertainty.kg.co2e',
        'refrigerants.emission.kg.co2e', 'refrigerants.uncertainty.kg.co2e'].join('\t') + '\n'
      csvContent += [
        ...emissions.meta.map(function (item) {
          let toReturn = item.name + '\t' + item.site + '\t'
          toReturn += item.area + '\t' + item.share + '\t'
          toReturn += item.selfConsumption + '\t' + item.selfProduction + '\t'
          toReturn += Math.round(item.heatingIntensity.intensity) + '\t' + Math.round(item.heatingIntensity.uncertainty) + '\t'
          toReturn += Math.round(item.electricityIntensity.intensity) + '\t' + Math.round(item.electricityIntensity.uncertainty) + '\t'
          toReturn += Math.round(item.refrigerantsIntensity.intensity) + '\t' + Math.round(item.refrigerantsIntensity.uncertainty)
          return toReturn
        })
      ]
        .join('\n')
        .replace(/(^\[)|(\]$)/gm, '')
      const data = encodeURI(csvContent)
      const link = document.createElement('a')
      link.setAttribute('href', data)
      link.setAttribute('download', 'GES1point5_ghgi' + this.GHGIyear + '_buildings_' + now.getFullYear() + '' + month + '' + now.getDate() + '.tsv')
      link.click()
    },
    csvExport (module) {
      if (module === 'commutes') {
        this.exportCommutes(this.GHGIyear)
      } else if (module === 'travels') {
        this.exportTravels()
      } else if (module === 'devices') {
        this.exportDevices()
      } else if (module === 'vehicles') {
        this.exportVehicles()
      } else if (module === 'purchases') {
        this.exportPurchases()
      } else if (module === 'buildings') {
        this.exportBuildings()
      } else {
        this.exportGlobal()
      }
    },
    isDisabled: function (module) {
      return (this.syntheseData[module].intensity.intensity === 0)
    },
    isOK2Submit: function (module) {
      let isOK2Submit = true
      if (module === 'commutes' && !this.commutesIsOK) {
        isOK2Submit = false
        this.errorMsg = this.$t('error-1')
      } else if (module === 'commutes' && this.surveyActive) {
        isOK2Submit = false
        this.errorMsg = this.$t('error-2')
      } else if (module === 'travels' && !this.travelsIsOK) {
        isOK2Submit = false
        this.errorMsg = this.$t('error-3')
      } else if (module === 'buildings' && !this.buildingsIsOK) {
        isOK2Submit = false
        this.errorMsg = this.$t('error-4')
      } else if (module === 'purchases' && !this.purchasesIsOK) {
        isOK2Submit = false
        this.errorMsg = this.$t('error-5')
      } else if (module === 'total') {
        if (!this.commutesIsOK) {
          isOK2Submit = false
          this.errorMsg = this.$t('error-1')
        } else if (this.surveyActive) {
          isOK2Submit = false
          this.errorMsg = this.$t('error-2')
        } else if (!this.travelsIsOK) {
          isOK2Submit = false
          this.errorMsg = this.$t('error-3')
        } else if (!this.buildingsIsOK) {
          isOK2Submit = false
          this.errorMsg = this.$t('error-4')
        } else if (!this.purchasesIsOK) {
          isOK2Submit = false
          this.errorMsg = this.$t('error-5')
        }
      }
      return isOK2Submit
    },
    submitData: function (module) {
      if (this.isOK2Submit(module)) {
        this.currentModule = module
        this.displayModal = true
      } else {
        let self = this
        this.$buefy.dialog.alert({
          title: self.$t('title-2'),
          canCancel: ['escape', 'outside'],
          message: self.errorMsg,
          confirmText: self.$t('validate')
        })
      }
    },
    processBuildings: function () {
      if (this.$store.getters['buildings/hasItems'] && this.$store.getters['buildings/computed']) {
        let results = this.$store.getters['buildings/results']
        this.graphicData.push({
          name: this.$t('heating'),
          y: Math.round(results.heatings.intensity.intensity),
          color: HEATING_COLOR
        })
        this.syntheseData.heatings.intensity = results.heatings.intensity
        this.syntheseData.buildings.intensity.add(results.heatings.intensity)
        this.syntheseData.total.intensity.add(results.heatings.intensity)

        this.graphicData.push({
          name: this.$t('electricity'),
          y: Math.round(results.electricity.intensity),
          color: ELECTRICITY_COLOR
        })
        this.syntheseData.electricity.intensity = results.electricity
        this.syntheseData.buildings.intensity.add(results.electricity)
        this.syntheseData.total.intensity.add(results.electricity)

        this.graphicData.push({
          name: this.$t('refrigerants'),
          y: Math.round(results.refrigerants.intensity),
          color: REFRIGERANTS_COLOR
        })
        this.syntheseData.cooling.intensity = results.refrigerants
        this.syntheseData.buildings.intensity.add(results.refrigerants)
        this.syntheseData.total.intensity.add(results.refrigerants)
      }
    },
    processVehicles: function () {
      if (this.$store.getters['vehicles/hasItems'] && this.$store.getters['vehicles/computed']) {
        let results = this.$store.getters['vehicles/results']
        let index = this.graphicData.findIndex(obj => obj.name === this.$t('post-5'))
        if (index === -1) {
          this.graphicData.push({
            name: this.$t('post-5'),
            y: Math.round(results.intensity.intensity),
            color: VEHICLES_COLOR
          })
        } else {
          this.graphicData[index].y += Math.round(results.intensity.intensity)
        }
        this.syntheseData.vehicles.intensity = results.intensity
        this.syntheseData.proTravels.intensity.add(results.intensity)
        this.syntheseData.alltravels.intensity.add(results.intensity)
        this.syntheseData.total.intensity.add(results.intensity)
      }
    },
    processCommutes: function () {
      if (this.$store.getters['commutes/hasItems'] && this.$store.getters['commutes/computed']) {
        let results = this.$store.getters['commutes/results']
        this.graphicData.push({
          name: this.$t('post-4'),
          y: Math.round(results.intensity.intensity),
          color: COMMUTES_COLOR
        })
        this.syntheseData.commutes.intensity = results.intensity
        this.syntheseData.alltravels.intensity.add(results.intensity)
        this.syntheseData.total.intensity.add(results.intensity)
      }
    },
    processTravels: function () {
      if (this.$store.getters['travels/hasItems'] && this.$store.getters['travels/computed']) {
        let results = this.$store.getters['travels/results']
        let intensity = new CarbonIntensity(
          results.intensity.intensity,
          results.intensity.uncertainty
        )
        if (this.withContrails) {
          intensity = new CarbonIntensity(
            results.intensity.intensitywc,
            results.intensity.uncertaintywc
          )
        }
        let index = this.graphicData.findIndex(obj => obj.name === this.$t('post-5'))
        if (index === -1) {
          this.graphicData.push({
            name: this.$t('post-5'),
            y: Math.round(intensity.intensity),
            color: TRAVELS_COLOR
          })
        } else {
          this.graphicData[index].y += Math.round(intensity.intensity)
        }
        this.syntheseData.travels.intensity = intensity
        this.syntheseData.proTravels.intensity.add(intensity)
        this.syntheseData.alltravels.intensity.add(intensity)
        this.syntheseData.total.intensity.add(intensity)
      }
    },
    processComputerDevices: function () {
      if (this.$store.getters['computerdevices/hasItems'] && this.$store.getters['computerdevices/computed']) {
        let results = this.$store.getters['computerdevices/results']
        this.graphicData.push({
          name: this.$t('computer.devices'),
          y: Math.round(results.intensity.intensity),
          color: COMPUTERDEVICES_COLOR
        })
        this.syntheseData.devices.intensity = results.intensity
        this.syntheseData.total.intensity.add(results.intensity)
      }
    },
    processPurchases: function () {
      if (this.$store.getters['purchases/hasItems'] && this.$store.getters['purchases/computed']) {
        let results = this.$store.getters['purchases/results']
        this.graphicData.push({
          name: this.$t('purchases'),
          y: Math.round(results.intensity.intensity),
          color: PURCHASES_COLOR
        })
        this.syntheseData.purchases.intensity = results.intensity
        this.syntheseData.total.intensity.add(results.intensity)
      }
    }
  },
  watch: {
    '$i18n.locale': function () {
      this.forceComputeAllModules()
    }
  },
  mounted () {
    let self = this
    this.computeAllModules()
    setTimeout(function () {
      self.$refs.purchasesWarning[0].forceComputation()
    }, 5)
  }
}
</script>

<style>
.has-text-distance {
  color: #935458 !important;
}
.has-text-carbone {
  color: #8e6a9e !important;
}
.has-text-carbone2 {
  color: #208dbc !important;
}
.heading .tooltip-content {
  text-transform: none;
}
.heading .b-tooltip.is-multiline.is-large .tooltip-content {
    width: 500px;
}
.b-tooltip.is-multiline .tooltip-content {
    text-align: left !important;
}
</style>
